# Written by Mads Engelund, 2017, http://espeem.com
from ase.atoms import Atom
from ase.atoms import Atoms as ASEAtoms
import numpy as np
from ase.visualize import view

from CalcTroll.ASEUtils.Atoms import Atoms
from CalcTroll.ASEUtils.AtomUtilities import removeCopies
from CalcTroll.Plugins.Systems.Molecule import Molecule

from CalcTroll import API
from CalcTroll.API import DEFAULT


st_atoms = Atoms(symbols='C3HCHCHCHC3HCHC7HCHCHCHCHCHC3HCHCHCHCHCH',
          pbc=np.array([False, False, False], dtype=bool),
          cell=np.array(
      [[ 23.91090993,   0.        ,   0.        ],
       [  0.        ,  25.68028514,   0.        ],
       [  0.        ,   0.        ,  12.00027972]]),
          positions=np.array(
      [[ -3.75409888e+00,  -7.70064798e-01,  -2.13522920e-06],
       [ -3.76497722e+00,   6.71419420e-01,  -3.92178366e-05],
       [ -5.01958816e+00,   1.35675925e+00,  -9.39098671e-05],
       [ -5.02885219e+00,   2.45986793e+00,  -1.23956008e-04],
       [ -6.21057828e+00,   6.45780647e-01,  -1.17367754e-04],
       [ -7.17234098e+00,   1.18291429e+00,  -1.69213871e-04],
       [ -6.19989173e+00,  -7.80041247e-01,  -7.67618864e-05],
       [ -7.15343520e+00,  -1.33166059e+00,  -9.93487483e-05],
       [ -4.99873042e+00,  -1.47340572e+00,  -1.26568555e-05],
       [ -4.99256125e+00,  -2.57658115e+00,   2.51941170e-05],
       [ -1.27794318e+00,  -7.54613328e-01,   2.56391548e-05],
       [ -1.28907995e+00,   6.93274408e-01,   3.16924105e-06],
       [ -2.52481245e+00,   1.35584385e+00,  -3.09378041e-05],
       [ -2.56659378e+00,   2.45522324e+00,  -6.40849222e-05],
       [ -2.50365390e+00,  -1.43598886e+00,   2.85152318e-05],
       [ -2.52940902e+00,  -2.53602705e+00,   4.61310050e-05],
       [  1.25799302e+00,  -7.50675697e-01,   9.77284084e-06],
       [  1.24615934e+00,   7.29695213e-01,  -5.30764531e-07],
       [ -1.28355771e-02,   1.44395259e+00,   7.35185606e-06],
       [  1.04014608e-02,  -1.48501154e+00,   3.32492493e-05],
       [  1.21226995e+00,   3.59604884e+00,  -6.31837338e-07],
       [  2.46566424e+00,   2.88459030e+00,  -2.04410492e-05],
       [  3.68666711e+00,   3.62792163e+00,  -4.78312507e-05],
       [  4.64596631e+00,   3.08355480e+00,  -6.59042328e-05],
       [  3.66746050e+00,   5.01470669e+00,  -5.30219479e-05],
       [  4.61420064e+00,   5.57806730e+00,  -7.43710648e-05],
       [  2.42757502e+00,   5.71902602e+00,  -2.87671201e-05],
       [  2.42756860e+00,   6.82064466e+00,  -2.93687943e-05],
       [  1.22612896e+00,   5.02567128e+00,  -1.43724473e-06],
       [  2.67442246e-01,   5.57137537e+00,   1.84957945e-05],
       [  2.43786542e+00,   1.46848255e+00,  -1.26610889e-05],
       [  3.41085135e+00,   9.55401143e-01,  -1.43952019e-05],
       [  1.04479839e-02,   2.84620058e+00,   1.65500107e-05],
       [ -9.28433866e-01,   3.41954315e+00,   3.77610124e-05],
       [  2.51241374e+00,  -2.88554259e+00,   1.89979835e-05],
       [  1.27025029e+00,  -3.61726938e+00,   4.64077645e-05],
       [  1.30722455e+00,  -5.04660489e+00,   5.58779161e-05],
       [  3.58004501e-01,  -5.60875943e+00,   7.63978127e-05],
       [  2.51986768e+00,  -5.72015205e+00,   3.62089362e-05],
       [  2.53793842e+00,  -6.82161245e+00,   3.67899726e-05],
       [  3.74826206e+00,  -4.99610007e+00,   1.41861770e-05],
       [  4.70370627e+00,  -5.54451473e+00,   1.77591801e-06],
       [  3.74554750e+00,  -3.60908221e+00,   9.29975660e-06],
       [  4.69669768e+00,  -3.05002884e+00,  -2.40987206e-06],
       [  5.61991229e-02,  -2.88677221e+00,   5.37850211e-05],
       [ -8.74206166e-01,  -3.47406693e+00,   7.34132544e-05],
       [  2.46166399e+00,  -1.46991692e+00,   1.40231905e-07],
       [  3.42615668e+00,  -9.40482998e-01,  -2.72261566e-05]]))

class StarPhene(Molecule):
    def __init__(self):
        Molecule.__init__(self, atoms=st_atoms)


class SquareStarPhene(Molecule):
    def __init__(self):
        atoms = Atoms(
            [
            Atom('C', ( 8.46865, 12.3316,  5.1, )),
            Atom('C', ( 8.45722, 13.7215,  5.1, )),
            Atom('C', ( 7.24847, 14.4039,  5.1, )),
            Atom('H', ( 7.23946, 15.4976,  5.1, )),
            Atom('C', ( 6.05114, 13.6965,  5.1, )),
            Atom('H', ( 5.1,     14.2335,  5.1, )),
            Atom('C', ( 6.0626,  12.3066,  5.1, )),
            Atom('H', ( 5.12044, 11.7499,  5.1, )),
            Atom('C', ( 7.27133, 11.6242,  5.1, )),
            Atom('H', ( 7.28039, 10.5305,  5.1, )),
            Atom('C', ( 9.95115, 12.3316,  5.1, )),
            Atom('C', ( 9.96258, 13.7215,  5.1, )),
            Atom('C', ( 11.1713, 14.4039,  5.1, )),
            Atom('H', ( 11.1803, 15.4976,  5.1, )),
            Atom('C', ( 12.3687, 13.6965,  5.1, )),
            Atom('C', ( 12.3572, 12.3066,  5.1, )),
            Atom('C', ( 11.1485, 11.6242,  5.1, )),
            Atom('H', ( 11.1394, 10.5305,  5.1, )),
            Atom('C', ( 15.4761, 17.7423,  5.1, )),
            Atom('C', ( 16.6856, 17.0572,  5.1, )),
            Atom('C', ( 17.8809, 17.7628,  5.1, )),
            Atom('H', ( 18.8326, 17.2238,  5.1, )),
            Atom('C', ( 17.8669, 19.1535,  5.1, )),
            Atom('H', ( 18.8075, 19.7087,  5.1, )),
            Atom('C', ( 16.6575, 19.8385,  5.1, )),
            Atom('H', ( 16.6465, 20.9327,  5.1, )),
            Atom('C', ( 15.4622, 19.1329,  5.1, )),
            Atom('H', ( 14.5105, 19.6719,  5.1, )),
            Atom('C', ( 14.7349, 16.4584,  5.1, )),
            Atom('C', ( 15.9329, 15.7535,  5.1, )),
            Atom('C', ( 15.9195, 14.3655,  5.1, )),
            Atom('H', ( 16.8622, 13.8109,  5.1, )),
            Atom('C', ( 14.7082, 13.6823,  5.1, )),
            Atom('C', ( 13.5102, 14.3872,  5.1, )),
            Atom('C', ( 13.5236, 15.7752,  5.1, )),
            Atom('H', ( 12.5809, 16.3299,  5.1, )),
            Atom('C', ( 16.6582, 8.96828,  5.1, )),
            Atom('C', ( 15.4602, 8.26342,  5.1, )),
            Atom('C', ( 15.4736, 6.87542,  5.1, )),
            Atom('H', ( 14.5309, 6.32074,  5.1, )),
            Atom('C', ( 16.6849, 6.19221,  5.1, )),
            Atom('H', ( 16.6954, 5.1    ,  5.1, )),
            Atom('C', ( 17.8829, 6.89708,  5.1, )),
            Atom('H', ( 18.836,  6.35947,  5.1, )),
            Atom('C', ( 17.8695, 8.28507,  5.1, )),
            Atom('H', ( 18.8121, 8.83977,  5.1, )),
            Atom('C', ( 15.917,  10.2522,  5.1, )),
            Atom('C', ( 14.7075, 9.5671 ,  5.1, )),
            Atom('C', ( 13.5122, 10.2727,  5.1, )),
            Atom('H', ( 12.5605, 9.73365,  5.1, )),
            Atom('C', ( 13.5262, 11.6633,  5.1, )),
            Atom('C', ( 14.7356, 12.3484,  5.1, )),
            Atom('C', ( 15.9309, 11.6428,  5.1, )),
            Atom('H', ( 16.8826, 12.1818,  5.1, )),
            ],
            cell=(23.9360246543, 26.0327464664, 10.2, ),
            pbc=False,
            )
        cell = atoms.cell.sum(axis=0)
        atoms.positions -= cell/2.
        atoms.positions[:,0] -= 1.58
        Molecule.__init__(self, atoms=atoms)


class FSquareStarPhene(Molecule):
    def __init__(self):
        atoms = Atoms(
            [
            Atom('C', ( 8.46865, 12.3316,  5.1, )),
            Atom('C', ( 8.45722, 13.7215,  5.1, )),
            Atom('C', ( 7.24847, 14.4039,  5.1, )),
            Atom('H', ( 7.23946, 15.4976,  5.1, )),
            Atom('C', ( 6.05114, 13.6965,  5.1, )),
            Atom('F', ( 5.1,     14.2335,  5.1, )),
            Atom('C', ( 6.0626,  12.3066,  5.1, )),
            Atom('F', ( 5.12044, 11.7499,  5.1, )),
            Atom('C', ( 7.27133, 11.6242,  5.1, )),
            Atom('H', ( 7.28039, 10.5305,  5.1, )),
            Atom('C', ( 9.95115, 12.3316,  5.1, )),
            Atom('C', ( 9.96258, 13.7215,  5.1, )),
            Atom('C', ( 11.1713, 14.4039,  5.1, )),
            Atom('H', ( 11.1803, 15.4976,  5.1, )),
            Atom('C', ( 12.3687, 13.6965,  5.1, )),
            Atom('C', ( 12.3572, 12.3066,  5.1, )),
            Atom('C', ( 11.1485, 11.6242,  5.1, )),
            Atom('H', ( 11.1394, 10.5305,  5.1, )),
            Atom('C', ( 15.4761, 17.7423,  5.1, )),
            Atom('C', ( 16.6856, 17.0572,  5.1, )),
            Atom('C', ( 17.8809, 17.7628,  5.1, )),
            Atom('H', ( 18.8326, 17.2238,  5.1, )),
            Atom('C', ( 17.8669, 19.1535,  5.1, )),
            Atom('F', ( 18.8075, 19.7087,  5.1, )),
            Atom('C', ( 16.6575, 19.8385,  5.1, )),
            Atom('F', ( 16.6465, 20.9327,  5.1, )),
            Atom('C', ( 15.4622, 19.1329,  5.1, )),
            Atom('H', ( 14.5105, 19.6719,  5.1, )),
            Atom('C', ( 14.7349, 16.4584,  5.1, )),
            Atom('C', ( 15.9329, 15.7535,  5.1, )),
            Atom('C', ( 15.9195, 14.3655,  5.1, )),
            Atom('H', ( 16.8622, 13.8109,  5.1, )),
            Atom('C', ( 14.7082, 13.6823,  5.1, )),
            Atom('C', ( 13.5102, 14.3872,  5.1, )),
            Atom('C', ( 13.5236, 15.7752,  5.1, )),
            Atom('H', ( 12.5809, 16.3299,  5.1, )),
            Atom('C', ( 16.6582, 8.96828,  5.1, )),
            Atom('C', ( 15.4602, 8.26342,  5.1, )),
            Atom('C', ( 15.4736, 6.87542,  5.1, )),
            Atom('H', ( 14.5309, 6.32074,  5.1, )),
            Atom('C', ( 16.6849, 6.19221,  5.1, )),
            Atom('F', ( 16.6954, 5.1    ,  5.1, )),
            Atom('C', ( 17.8829, 6.89708,  5.1, )),
            Atom('F', ( 18.836,  6.35947,  5.1, )),
            Atom('C', ( 17.8695, 8.28507,  5.1, )),
            Atom('H', ( 18.8121, 8.83977,  5.1, )),
            Atom('C', ( 15.917,  10.2522,  5.1, )),
            Atom('C', ( 14.7075, 9.5671 ,  5.1, )),
            Atom('C', ( 13.5122, 10.2727,  5.1, )),
            Atom('H', ( 12.5605, 9.73365,  5.1, )),
            Atom('C', ( 13.5262, 11.6633,  5.1, )),
            Atom('C', ( 14.7356, 12.3484,  5.1, )),
            Atom('C', ( 15.9309, 11.6428,  5.1, )),
            Atom('H', ( 16.8826, 12.1818,  5.1, )),
            ],
            cell=(23.9360246543, 26.0327464664, 10.2, ),
            pbc=False,
            )
        cell = atoms.cell.sum(axis=0)
        atoms.positions -= cell/2.
        atoms.positions[:,0] -= 1.58
        Molecule.__init__(self, atoms=atoms)

atoms = Atoms(
            symbols='C3HCHCHCHC3HCHC4H4',
            pbc=np.array([False, False, False], dtype=bool),
            cell=np.array(
                 [[ 40.,   0.,   0.],
                  [  0.,  36.,   0.],
                  [  0.,   0.,  31.]]),
            positions=np.array(
                 [[ 18.76607037,  17.21357051,  15.47449304],
                  [ 18.76614589,  18.67276128,  15.49834605],
                  [ 17.50366688,  19.36207552,  15.52312493],
                  [ 17.50344228,  20.46669775,  15.54051419],
                  [ 16.30775943,  18.65939004,  15.52503037],
                  [ 15.34673811,  19.20170741,  15.5438117 ],
                  [ 16.30767331,  17.22663756,  15.50316626],
                  [ 15.34663255,  16.6839851 ,  15.50561954],
                  [ 17.50345125,  16.52412661,  15.47880749],
                  [ 17.50309943,  15.41952264,  15.46138951],
                  [ 21.23717267,  17.21383834,  15.44060936],
                  [ 21.23729604,  18.67303876,  15.46724478],
                  [ 20.0018055 ,  19.36119865,  15.49532096],
                  [ 20.00195263,  20.46679705,  15.5143428 ],
                  [ 20.00152658,  16.52534996,  15.44622535],
                  [ 20.00134642,  15.41971206,  15.42695851],
                  [ 23.69543344,  17.22763494,  15.40346416],
                  [ 23.6956171 ,  18.66024303,  15.43083983],
                  [ 22.49988868,  19.36260914,  15.46216613],
                  [ 22.49959802,  16.52479886,  15.40863341],
                  [ 24.65629686,  16.6853106 ,  15.3785011 ],
                  [ 24.656661  ,  19.20279702,  15.42687254],
                  [ 22.50020387,  20.46716398,  15.48306843],
                  [ 22.49972713,  15.42024129,  15.38803276]]))
cell = atoms.cell.sum(axis=0)
atoms.positions -= cell/2.
MiniPhene = Molecule(atoms, name='MiniPhene')


def makeEnes(number):
    atoms = Atoms(
        [
        Atom('H', ( -1.0*np.cos(np.pi/6.), 0.7+1.0*np.sin(np.pi/6.)  ,0.0,)),
        Atom('H', ( -1.0*np.cos(np.pi/6.), -0.7-1.0*np.sin(np.pi/6.)  ,0.0,)),
        ],
        cell=(2.41, 16.00, 10),
        pbc=[False, False, False],
        )
    atoms_unit = Atoms(
        [
        Atom('C', ( 0.0,  0.7 ,0.0,)),
        Atom('C', ( 0.0, -0.7 ,0.0,)),
        Atom('H', ( 1.2, -2.4 ,0.0,)),
        Atom('C', ( 1.2, -1.4 ,0.0,)),
        Atom('C', ( 1.2,  1.4 ,0.0,)),
        Atom('H', ( 1.2,  2.4 ,0.0,)),
        ],
        cell=(2.41, 16.00, 10),
        pbc=[False, False, True],
        )
    atoms += atoms_unit.repeat((number+1, 1, 1))
    atoms = atoms[:-4]
    max_x = atoms.positions[-1, 0]

    postpend = Atoms(
        [
        Atom('H', ( max_x + 1.0*np.cos(np.pi/6.), 0.7+1.0*np.sin(np.pi/6.)  ,0.0,)),
        Atom('H', ( max_x + 1.0*np.cos(np.pi/6.), -0.7-1.0*np.sin(np.pi/6.)  ,0.0,)),
        ],
        cell=(2.41, 16.00, 10),
        pbc=[False, False, True],
        )
    atoms += postpend

    maxi = atoms.positions.max(axis=0)
    mini = atoms.positions.min(axis=0)
    av = (maxi + mini)/2.
    ran = maxi-mini

    atoms.positions -= av
    atoms.cell[0,0] = ran[0] + 10
    atoms.cell[1,1] = ran[1] + 10
    atoms.cell[2,2] = ran[2] + 10

    return atoms

def makeEneEndGroup(number):
    atoms = Atoms(
        [
        ],
        cell=(2.41, 16.00, 10),
        pbc=[False, False, False],
        )
    atoms_unit = Atoms(
        [
        Atom('C', ( 0.0,  0.7 ,0.0,)),
        Atom('C', ( 0.0, -0.7 ,0.0,)),
        Atom('H', ( 1.2, -2.4 ,0.0,)),
        Atom('C', ( 1.2, -1.4 ,0.0,)),
        Atom('C', ( 1.2,  1.4 ,0.0,)),
        Atom('H', ( 1.2,  2.4 ,0.0,)),
        ],
        cell=(2.41, 16.00, 10),
        pbc=[False, False, True],
        )
    atoms += atoms_unit.repeat((number+1, 1, 1))
    atoms = atoms[:-4]
    max_x = atoms.positions[-1, 0]

    postpend = Atoms(
        [
        Atom('H', ( max_x + 1.0*np.cos(np.pi/6.), 0.7+1.0*np.sin(np.pi/6.)  ,0.0,)),
        Atom('H', ( max_x + 1.0*np.cos(np.pi/6.), -0.7-1.0*np.sin(np.pi/6.)  ,0.0,)),
        ],
        cell=(2.41, 16.00, 10),
        pbc=[False, False, True],
        )
    atoms += postpend
    maxi = atoms.positions.max(axis=0)
    mini = atoms.positions.min(axis=0)
    atoms.positions[:, 0] += 2.41/2.0

    av = (maxi + mini)/2.
    ran = maxi-mini
    atoms.cell[0,0] = ran[0] + 10
    atoms.cell[1,1] = ran[1] + 10
    atoms.cell[2,2] = ran[2] + 10

    return atoms

def triplicateEndGroup(group):
    group2 = group.copy()
    group2.rotate(v=(0,0,1), a=120)
    group3 = group.copy()
    group3.rotate(v=(0,0,1), a=240)

    atoms = group.copy()
    atoms += group2
    atoms += group3

    atoms.rotate(v=(0,0,1), a=180)

    return atoms


class Decaphene(Molecule):
    def __init__(self):
        group1 = makeEneEndGroup(3)
        atoms = triplicateEndGroup(group1)
        Molecule.__init__(self, atoms=atoms, name='Decaphene')


class Acene(Molecule):
    def __init__(self, number, name=DEFAULT):
        if name is DEFAULT:
            name_dict = {
                0:'Ethene',
                1:'Benzene',
                2:'Naphthalene',
                3:'Anthracene',
                4:'Tetracene',
                5:'Pentacene',
                6:'Hexacene',
                7:'Heptacene',
                8:'Octacene',
                9:'Nonacene',
                10:'Decacene',
                    }
            name = name_dict[number]

        self.__name = name
        self.__number = number
        atoms = makeEnes(number)
        Molecule.__init__(self, atoms, name=name)

